#This is a simple example to plot any TCL expression
#ask for the trusted security policy (hopefully, next release, the lhea policy
#will be an option, but it's currently broken)
policy trusted

#load the POW features (it's built into the plugin as a "static package")
load "" pow

#make a place to put the POW window
frame .powholder 
grid .powholder -column 0 -row 0 -columnspan 4

#open up a POW window to plot stuff in
#arguments mean:
# "safe" - tell POW we're running in a browser so don't try to manage the X
#          color resources
# ".powholder"    - where to put the POW window
# "1"             - include the standard POW GUI (use 0 to suppress the POW
#                   GUI for more specialized applications)
powInit safe .powholder 1

#tell the POW window how big to be
.pow.pow configure -width 380 -height 380

#Get the function to plot
button .plotbutton -text "Plot Function" -command \
    {plotFunc $exprString $rMin $rMax}
grid .plotbutton -column 0 -row 1 -sticky ew -columnspan 2

set exprString {sin($x)}
entry .exprentry -textvariable exprString -width 40
grid .exprentry -column 2 -row 1 -sticky ew -columnspan 2

#Get the range they want
set rMin 0
label .minlab -text XMin
entry .minentry -textvariable rMin -width 10
grid .minlab  -column 0 -row 2 -sticky ew
grid .minentry -column 1 -row 2 -sticky ew

set rMax 6.2831853
label .maxlab -text XMax
entry .maxentry -textvariable rMax -width 10
grid .maxlab  -column 2 -row 2 -sticky ew
grid .maxentry -column 3 -row 2 -sticky ew

set ext 0



proc plotFunc {exprstring min max} {
    global ext    
#create a curve
    makeCurve $exprstring $min $max
#Check to see if a graph exists
    if {[powListGraphs] != "" } {
#add new curve to graph
	powPlotCurves MyFunctions "curve_$ext" 
#call function to rescale the graph to show all curves 
	powEndROI 1
    } else {
#no graph, make one
	powCreateGraph MyFunctions "curve_$ext" NULL NULL NULL NULL NULL 300 300
    }

}

proc makeCurve {exprstring min max} {
global ext
#make a new curve name
    incr ext
    set curve "curve_${ext}"
#calculate 100 curve points
    set deltx [expr double($max - $min)/100.0]
    set i 0
    catch {unset xvect}
    catch {unset yvect}
    for {set x $min} {$x < $max} {set x [expr $x + $deltx]} {
	lappend xvect $x
	lappend yvect [expr $exprstring]
	incr i
    }
#Make powData objects from TCL lists
    powCreateDataFromList xdata $xvect
    powCreateDataFromList ydata $yvect
    
#Make powVector objects from powData objects
    powCreateVector xvector xdata 0 $i NULL
    powCreateVector yvector ydata 0 $i NULL

#Make powCurve object from powVector objects
    powCreateCurve "curve_$ext" xvector NULL yvector NULL
    
}    